'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var stampit = _interopDefault(require('stampit'));

var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var noop = function noop() {};
var singletons = new Map();

/**
 * Returns a factory function
 */
function factory(spec) {
	var _stampit;

	var _spec$compose = spec.compose;
	var compose = _spec$compose === undefined ? [] : _spec$compose;
	var _spec$refs = spec.refs;
	var refs = _spec$refs === undefined ? {} : _spec$refs;
	var _spec$props = spec.props;
	var props = _spec$props === undefined ? {} : _spec$props;
	var _spec$init = spec.init;
	var init = _spec$init === undefined ? noop : _spec$init;
	var _spec$methods = spec.methods;
	var methods = _spec$methods === undefined ? {} : _spec$methods;


	return (_stampit = stampit()).compose.apply(_stampit, toConsumableArray(compose)).refs(refs).props(props).init(init).methods(methods);
}

/**
 * Returns a singleton instance of
 * the given constructor or factory
 */
function singleton(Ctor) {
	if (!singletons.has(Ctor)) {
		var instance = void 0;
		try {
			instance = Ctor();
		} catch (err) {
			instance = new Ctor();
		}
		singletons.set(Ctor, instance);
	}

	return singletons.get(Ctor);
}

exports['default'] = factory;
exports.factory = factory;
exports.singleton = singleton;